SystemOrganization addCategory: #'Tropo-Core'!

Object subclass: #TPConversation
	instanceVariableNames: 'id from requests responses'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Tropo-Core'!

!TPConversation class methodsFor: 'as yet unclassified' stamp: 'PaulDeBruicker 12/28/2010 17:29'!
eraseConversationWith: aNumber
	self instances remove:[self instances findByFrom: aNumber]! !

!TPConversation class methodsFor: 'as yet unclassified' stamp: 'PaulDeBruicker 12/29/2010 14:33'!
eraseConversations
	self instances copy do:[:each | self instances remove: each]! !

!TPConversation class methodsFor: 'as yet unclassified' stamp: 'PaulDeBruicker 12/28/2010 17:12'!
findByFrom: aFromNumber
|tmp|
	^ self instances detect: [ :each | each from = aFromNumber  ] ifNone: [ tmp:=self new from: aFromNumber.
																	self instances add: tmp. ]! !

!TPConversation class methodsFor: 'as yet unclassified' stamp: 'PaulDeBruicker 12/29/2010 12:32'!
findById: aSessionId
|tmp|
	^ self instances detect: [ :each | each id = aSessionId ] ifNone: [tmp:=self new id: aSessionId.
																	self instances add: tmp. ]! !

!TPConversation methodsFor: 'accessing' stamp: 'PaulDeBruicker 12/28/2010 17:02'!
from
	^ from! !

!TPConversation methodsFor: 'accessing' stamp: 'PaulDeBruicker 12/28/2010 17:02'!
from: anObject
	from := anObject! !

!TPConversation methodsFor: 'accessing' stamp: 'PaulDeBruicker 12/28/2010 15:40'!
id
	^ id! !

!TPConversation methodsFor: 'accessing' stamp: 'PaulDeBruicker 12/28/2010 15:40'!
id: anObject
	id := anObject! !

!TPConversation methodsFor: 'as yet unclassified' stamp: 'PaulDeBruicker 12/28/2010 14:52'!
initialize
	super initialize.
	requests := OrderedCollection new.
	responses := OrderedCollection new.! !

!TPConversation methodsFor: 'accessing' stamp: 'PaulDeBruicker 12/28/2010 15:40'!
requests
	^ requests! !

!TPConversation methodsFor: 'accessing' stamp: 'PaulDeBruicker 12/28/2010 15:40'!
requests: anObject
	requests := anObject! !

!TPConversation methodsFor: 'accessing' stamp: 'PaulDeBruicker 12/28/2010 15:40'!
responses
	^ responses! !

!TPConversation methodsFor: 'accessing' stamp: 'PaulDeBruicker 12/28/2010 15:40'!
responses: anObject
	responses := anObject! !

TPConversation subclass: #TPSmsConversation
	instanceVariableNames: 'messages'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Tropo-Core'!

!TPSmsConversation class methodsFor: 'as yet unclassified' stamp: 'PaulDeBruicker 12/28/2010 14:51'!
instances
	^ TPSmsService instancesOf: self! !

!TPSmsConversation methodsFor: 'accessing' stamp: 'PaulDeBruicker 12/28/2010 17:06'!
initialize 
	super initialize .
	messages := OrderedCollection new.! !

!TPSmsConversation methodsFor: 'accessing' stamp: 'PaulDeBruicker 12/28/2010 17:05'!
messages
	^ messages! !

!TPSmsConversation methodsFor: 'accessing' stamp: 'PaulDeBruicker 12/28/2010 17:05'!
messages: anObject
	messages := anObject! !

!TPSmsConversation methodsFor: 'as yet unclassified' stamp: 'PaulDeBruicker 12/30/2010 11:01'!
printLastMessageToTranscipt
	| msg |
	msg := requests last.
	
	Transcript
		show: 'From: ' ,  (((msg at:'session') at:'from') at: 'id') ;
		cr;
		show: 'Msg: ' , ((msg at:'session') at:'initialText');
		cr! !

TPConversation subclass: #TPVoiceConversation
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Tropo-Core'!

!TPVoiceConversation class methodsFor: 'as yet unclassified' stamp: 'PaulDeBruicker 12/28/2010 14:50'!
instances
	^ TPVoiceService instancesOf: self! !

Object subclass: #TPJsonObject
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Tropo-Core'!

TPJsonObject subclass: #TPAsk
	instanceVariableNames: 'choices attempts bargein minConfidence name recognizer required say timeout voice'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Tropo-Core'!

!TPAsk commentStamp: '<historical>' prior: 0!
https://www.tropo.com/docs/webapi/ask.htm

TPAsk has not been documented yet. The class comment should describe the purpose of the class, its collaborations and its variables.

Instance Variables:
	choices	<ProtoObject | PseudoContext>
	attempts	<ProtoObject | PseudoContext>
	bargein	<ProtoObject | PseudoContext>
	minConfidence	<ProtoObject | PseudoContext>
	name	<ProtoObject | PseudoContext>
	recognizer	<ProtoObject | PseudoContext>
	required	<ProtoObject | PseudoContext>
	say	<ProtoObject | PseudoContext>
	timeout	<ProtoObject | PseudoContext>
	voice	<ProtoObject | PseudoContext>!

!TPAsk methodsFor: 'accessing' stamp: 'PaulDeBruicker 12/28/2010 09:14'!
attempts
	^ attempts! !

!TPAsk methodsFor: 'accessing' stamp: 'PaulDeBruicker 12/28/2010 09:14'!
attempts: anObject
	attempts := anObject! !

!TPAsk methodsFor: 'accessing' stamp: 'PaulDeBruicker 12/28/2010 09:14'!
bargein
	^ bargein! !

!TPAsk methodsFor: 'accessing' stamp: 'PaulDeBruicker 12/28/2010 09:14'!
bargein: anObject
	bargein := anObject! !

!TPAsk methodsFor: 'accessing' stamp: 'PaulDeBruicker 12/28/2010 09:14'!
choices
	^ choices! !

!TPAsk methodsFor: 'accessing' stamp: 'PaulDeBruicker 12/28/2010 09:14'!
choices: anObject
	choices := anObject! !

!TPAsk methodsFor: 'accessing' stamp: 'PaulDeBruicker 12/28/2010 09:14'!
minConfidence
	^ minConfidence! !

!TPAsk methodsFor: 'accessing' stamp: 'PaulDeBruicker 12/28/2010 09:14'!
minConfidence: anObject
	minConfidence := anObject! !

!TPAsk methodsFor: 'accessing' stamp: 'PaulDeBruicker 12/28/2010 09:26'!
name
	^ name! !

!TPAsk methodsFor: 'accessing' stamp: 'PaulDeBruicker 12/28/2010 09:14'!
name: anObject
	name := anObject! !

!TPAsk methodsFor: 'accessing' stamp: 'PaulDeBruicker 12/28/2010 09:14'!
recognizer
	^ recognizer! !

!TPAsk methodsFor: 'accessing' stamp: 'PaulDeBruicker 12/28/2010 09:14'!
recognizer: anObject
	recognizer := anObject! !

!TPAsk methodsFor: 'accessing' stamp: 'PaulDeBruicker 12/28/2010 09:14'!
required
	^ required! !

!TPAsk methodsFor: 'accessing' stamp: 'PaulDeBruicker 12/28/2010 09:14'!
required: anObject
	required := anObject! !

!TPAsk methodsFor: 'accessing' stamp: 'PaulDeBruicker 12/28/2010 09:14'!
say
	^ say! !

!TPAsk methodsFor: 'accessing' stamp: 'PaulDeBruicker 12/28/2010 09:14'!
say: anObject
	say := anObject! !

!TPAsk methodsFor: 'accessing' stamp: 'PaulDeBruicker 12/28/2010 09:14'!
timeout
	^ timeout! !

!TPAsk methodsFor: 'accessing' stamp: 'PaulDeBruicker 12/28/2010 09:14'!
timeout: anObject
	timeout := anObject! !

!TPAsk methodsFor: 'as yet unclassified' stamp: 'PaulDeBruicker 12/28/2010 09:26'!
tropoMethod
	^'ask'! !

!TPAsk methodsFor: 'accessing' stamp: 'PaulDeBruicker 12/28/2010 09:14'!
voice
	^ voice! !

!TPAsk methodsFor: 'accessing' stamp: 'PaulDeBruicker 12/28/2010 09:14'!
voice: anObject
	voice := anObject! !

TPJsonObject subclass: #TPCall
	instanceVariableNames: 'to answerOnMedia channel from headers name network recording required timeout'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Tropo-Core'!

!TPCall commentStamp: '<historical>' prior: 0!
https://www.tropo.com/docs/webapi/call.htm

TPCall has not been documented yet. The class comment should describe the purpose of the class, its collaborations and its variables.

Instance Variables:
	to	<ProtoObject | PseudoContext>
	answerOnMedia	<ProtoObject | PseudoContext>
	channel	<ProtoObject | PseudoContext>
	from	<ProtoObject | PseudoContext>
	headers	<ProtoObject | PseudoContext>
	name	<ProtoObject | PseudoContext>
	network	<ProtoObject | PseudoContext>
	recording	<ProtoObject | PseudoContext>
	required	<ProtoObject | PseudoContext>
	timeout	<ProtoObject | PseudoContext>!

!TPCall methodsFor: 'accessing' stamp: 'PaulDeBruicker 12/28/2010 09:15'!
answerOnMedia
	^ answerOnMedia! !

!TPCall methodsFor: 'accessing' stamp: 'PaulDeBruicker 12/28/2010 09:15'!
answerOnMedia: anObject
	answerOnMedia := anObject! !

!TPCall methodsFor: 'accessing' stamp: 'PaulDeBruicker 12/28/2010 09:15'!
channel
	^ channel! !

!TPCall methodsFor: 'accessing' stamp: 'PaulDeBruicker 12/28/2010 09:15'!
channel: anObject
	channel := anObject! !

!TPCall methodsFor: 'accessing' stamp: 'PaulDeBruicker 12/28/2010 09:15'!
from
	^ from! !

!TPCall methodsFor: 'accessing' stamp: 'PaulDeBruicker 12/28/2010 09:15'!
from: anObject
	from := anObject! !

!TPCall methodsFor: 'accessing' stamp: 'PaulDeBruicker 12/28/2010 09:15'!
headers
	^ headers! !

!TPCall methodsFor: 'accessing' stamp: 'PaulDeBruicker 12/28/2010 09:15'!
headers: anObject
	headers := anObject! !

!TPCall methodsFor: 'accessing' stamp: 'PaulDeBruicker 12/28/2010 09:25'!
name
	^ name! !

!TPCall methodsFor: 'accessing' stamp: 'PaulDeBruicker 12/28/2010 09:15'!
name: anObject
	name := anObject! !

!TPCall methodsFor: 'accessing' stamp: 'PaulDeBruicker 12/28/2010 09:15'!
network
	^ network! !

!TPCall methodsFor: 'accessing' stamp: 'PaulDeBruicker 12/28/2010 09:15'!
network: anObject
	network := anObject! !

!TPCall methodsFor: 'accessing' stamp: 'PaulDeBruicker 12/28/2010 09:15'!
recording
	^ recording! !

!TPCall methodsFor: 'accessing' stamp: 'PaulDeBruicker 12/28/2010 09:15'!
recording: anObject
	recording := anObject! !

!TPCall methodsFor: 'accessing' stamp: 'PaulDeBruicker 12/28/2010 09:15'!
required
	^ required! !

!TPCall methodsFor: 'accessing' stamp: 'PaulDeBruicker 12/28/2010 09:15'!
required: anObject
	required := anObject! !

!TPCall methodsFor: 'accessing' stamp: 'PaulDeBruicker 12/28/2010 09:15'!
timeout
	^ timeout! !

!TPCall methodsFor: 'accessing' stamp: 'PaulDeBruicker 12/28/2010 09:15'!
timeout: anObject
	timeout := anObject! !

!TPCall methodsFor: 'accessing' stamp: 'PaulDeBruicker 12/28/2010 09:15'!
to
	^ to! !

!TPCall methodsFor: 'accessing' stamp: 'PaulDeBruicker 12/28/2010 09:15'!
to: anObject
	to := anObject! !

!TPCall methodsFor: 'as yet unclassified' stamp: 'PaulDeBruicker 12/28/2010 09:25'!
tropoMethod
	^'call'! !

TPJsonObject subclass: #TPConference
	instanceVariableNames: 'id mute name playTones required terminator'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Tropo-Core'!

!TPConference commentStamp: '<historical>' prior: 0!
https://www.tropo.com/docs/webapi/conference.htm

TPConference has not been documented yet. The class comment should describe the purpose of the class, its collaborations and its variables.

Instance Variables:
	id	<ProtoObject | PseudoContext>
	mute	<ProtoObject | PseudoContext>
	name	<ProtoObject | PseudoContext>
	playTones	<ProtoObject | PseudoContext>
	required	<ProtoObject | PseudoContext>
	terminator	<ProtoObject | PseudoContext>!

!TPConference methodsFor: 'accessing' stamp: 'PaulDeBruicker 12/28/2010 09:15'!
id
	^ id! !

!TPConference methodsFor: 'accessing' stamp: 'PaulDeBruicker 12/28/2010 09:15'!
id: anObject
	id := anObject! !

!TPConference methodsFor: 'accessing' stamp: 'PaulDeBruicker 12/28/2010 09:15'!
mute
	^ mute! !

!TPConference methodsFor: 'accessing' stamp: 'PaulDeBruicker 12/28/2010 09:15'!
mute: anObject
	mute := anObject! !

!TPConference methodsFor: 'accessing' stamp: 'PaulDeBruicker 12/28/2010 09:25'!
name
	^ name! !

!TPConference methodsFor: 'accessing' stamp: 'PaulDeBruicker 12/28/2010 09:15'!
name: anObject
	name := anObject! !

!TPConference methodsFor: 'accessing' stamp: 'PaulDeBruicker 12/28/2010 09:15'!
playTones
	^ playTones! !

!TPConference methodsFor: 'accessing' stamp: 'PaulDeBruicker 12/28/2010 09:15'!
playTones: anObject
	playTones := anObject! !

!TPConference methodsFor: 'accessing' stamp: 'PaulDeBruicker 12/28/2010 09:15'!
required
	^ required! !

!TPConference methodsFor: 'accessing' stamp: 'PaulDeBruicker 12/28/2010 09:15'!
required: anObject
	required := anObject! !

!TPConference methodsFor: 'accessing' stamp: 'PaulDeBruicker 12/28/2010 09:15'!
terminator
	^ terminator! !

!TPConference methodsFor: 'accessing' stamp: 'PaulDeBruicker 12/28/2010 09:15'!
terminator: anObject
	terminator := anObject! !

!TPConference methodsFor: 'as yet unclassified' stamp: 'PaulDeBruicker 12/28/2010 09:25'!
tropoMethod
	^'conference'! !

TPJsonObject subclass: #TPHangup
	instanceVariableNames: 'headers'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Tropo-Core'!

!TPHangup commentStamp: '<historical>' prior: 0!
https://www.tropo.com/docs/webapi/hangup.htm

TPHangup has not been documented yet. The class comment should describe the purpose of the class, its collaborations and its variables.

Instance Variables:
	headers	<ProtoObject | PseudoContext>!

!TPHangup methodsFor: 'accessing' stamp: 'PaulDeBruicker 12/28/2010 09:15'!
headers
	^ headers! !

!TPHangup methodsFor: 'accessing' stamp: 'PaulDeBruicker 12/28/2010 09:15'!
headers: anObject
	headers := anObject! !

!TPHangup methodsFor: 'as yet unclassified' stamp: 'PaulDeBruicker 12/28/2010 09:25'!
tropoMethod
	^'hangup'! !

!TPJsonObject methodsFor: 'as yet unclassified' stamp: 'PaulDeBruicker 12/29/2010 14:17'!
jsonOn: aStream
	| x y vars |
	vars := self class allInstVarNames.
	x := Dictionary new.
	y := Dictionary new.
	vars
		do: [ :each | 
			(self perform: each asSymbol) isNil
				ifFalse: [ x at: each put: (self perform: each asSymbol) ] ].
	"y at: self tropoMethod put: x."
	x jsonOn: aStream! !

!TPJsonObject methodsFor: 'as yet unclassified' stamp: 'PaulDeBruicker 9/6/2011 16:33'!
jsonWriteOn: aStream
	| x y vars |
	vars := self class allInstVarNames.
	x := Dictionary new.
	y := Dictionary new.
	vars
		do: [ :each | 
			(self perform: each asSymbol) isNil
				ifFalse: [ x at: each put: (self perform: each asSymbol) ] ].
	"y at: self tropoMethod put: x."
	x jsonOn: aStream! !

TPJsonObject subclass: #TPMessage
	instanceVariableNames: 'say to answerOnMedia channel from name network required timeout voice'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Tropo-Core'!

!TPMessage commentStamp: '<historical>' prior: 0!
https://www.tropo.com/docs/webapi/message.htm

TPMessage has not been documented yet. The class comment should describe the purpose of the class, its collaborations and its variables.

Instance Variables:
	say	<ProtoObject | PseudoContext>
	to	<ProtoObject | PseudoContext>
	answerOnMedia	<ProtoObject | PseudoContext>
	channel	<ProtoObject | PseudoContext>
	from	<ProtoObject | PseudoContext>
	name	<ProtoObject | PseudoContext>
	network	<ProtoObject | PseudoContext>
	required	<ProtoObject | PseudoContext>
	timeout	<ProtoObject | PseudoContext>
	voice	<ProtoObject | PseudoContext>!

!TPMessage methodsFor: 'accessing' stamp: 'PaulDeBruicker 12/14/2010 17:24'!
answerOnMedia
	^ answerOnMedia! !

!TPMessage methodsFor: 'accessing' stamp: 'PaulDeBruicker 12/14/2010 17:24'!
answerOnMedia: anObject
	answerOnMedia := anObject! !

!TPMessage methodsFor: 'accessing' stamp: 'PaulDeBruicker 12/14/2010 17:24'!
channel
	^ channel! !

!TPMessage methodsFor: 'accessing' stamp: 'PaulDeBruicker 12/14/2010 17:24'!
channel: anObject
	channel := anObject! !

!TPMessage methodsFor: 'accessing' stamp: 'PaulDeBruicker 12/14/2010 17:24'!
from
	^ from! !

!TPMessage methodsFor: 'accessing' stamp: 'PaulDeBruicker 12/14/2010 17:24'!
from: anObject
	from := anObject! !

!TPMessage methodsFor: 'accessing' stamp: 'PaulDeBruicker 12/14/2010 17:24'!
name
	^ name! !

!TPMessage methodsFor: 'accessing' stamp: 'PaulDeBruicker 12/14/2010 17:24'!
name: anObject
	name := anObject! !

!TPMessage methodsFor: 'accessing' stamp: 'PaulDeBruicker 12/14/2010 17:24'!
network
	^ network! !

!TPMessage methodsFor: 'accessing' stamp: 'PaulDeBruicker 12/14/2010 17:24'!
network: anObject
	network := anObject! !

!TPMessage methodsFor: 'accessing' stamp: 'PaulDeBruicker 12/14/2010 17:24'!
required
	^ required! !

!TPMessage methodsFor: 'accessing' stamp: 'PaulDeBruicker 12/14/2010 17:24'!
required: anObject
	required := anObject! !

!TPMessage methodsFor: 'accessing' stamp: 'PaulDeBruicker 12/14/2010 17:24'!
say
	^ say! !

!TPMessage methodsFor: 'accessing' stamp: 'PaulDeBruicker 12/14/2010 17:24'!
say: anObject
	say := anObject! !

!TPMessage methodsFor: 'accessing' stamp: 'PaulDeBruicker 12/14/2010 17:24'!
timeout
	^ timeout! !

!TPMessage methodsFor: 'accessing' stamp: 'PaulDeBruicker 12/14/2010 17:24'!
timeout: anObject
	timeout := anObject! !

!TPMessage methodsFor: 'accessing' stamp: 'PaulDeBruicker 12/14/2010 17:24'!
to
	^ to! !

!TPMessage methodsFor: 'accessing' stamp: 'PaulDeBruicker 12/14/2010 17:24'!
to: anObject
	to := anObject! !

!TPMessage methodsFor: 'as yet unclassified' stamp: 'PaulDeBruicker 12/28/2010 09:25'!
tropoMethod
	^'message'! !

!TPMessage methodsFor: 'accessing' stamp: 'PaulDeBruicker 12/14/2010 17:24'!
voice
	^ voice! !

!TPMessage methodsFor: 'accessing' stamp: 'PaulDeBruicker 12/14/2010 17:24'!
voice: anObject
	voice := anObject! !

TPJsonObject subclass: #TPOn
	instanceVariableNames: 'event name next required say'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Tropo-Core'!

!TPOn commentStamp: '<historical>' prior: 0!
https://www.tropo.com/docs/webapi/on.htm
TPOn has not been documented yet. The class comment should describe the purpose of the class, its collaborations and its variables.

Instance Variables:
	event	<ProtoObject | PseudoContext>
	name	<ProtoObject | PseudoContext>
	next	<ProtoObject | PseudoContext>
	required	<ProtoObject | PseudoContext>
	say	<ProtoObject | PseudoContext>!

!TPOn methodsFor: 'accessing' stamp: 'PaulDeBruicker 12/28/2010 09:17'!
event
	^ event! !

!TPOn methodsFor: 'accessing' stamp: 'PaulDeBruicker 12/28/2010 09:17'!
event: anObject
	event := anObject! !

!TPOn methodsFor: 'accessing' stamp: 'PaulDeBruicker 12/28/2010 09:17'!
name
	^ name
! !

!TPOn methodsFor: 'accessing' stamp: 'PaulDeBruicker 12/28/2010 09:17'!
name: anObject
	name := anObject! !

!TPOn methodsFor: 'accessing' stamp: 'PaulDeBruicker 12/28/2010 09:17'!
next
	^ next! !

!TPOn methodsFor: 'accessing' stamp: 'PaulDeBruicker 12/28/2010 09:17'!
next: anObject
	next := anObject! !

!TPOn methodsFor: 'accessing' stamp: 'PaulDeBruicker 12/28/2010 09:17'!
required
	^ required! !

!TPOn methodsFor: 'accessing' stamp: 'PaulDeBruicker 12/28/2010 09:17'!
required: anObject
	required := anObject! !

!TPOn methodsFor: 'accessing' stamp: 'PaulDeBruicker 12/28/2010 09:17'!
say
	^ say! !

!TPOn methodsFor: 'accessing' stamp: 'PaulDeBruicker 12/28/2010 09:17'!
say: anObject
	say := anObject! !

!TPOn methodsFor: 'as yet unclassified' stamp: 'PaulDeBruicker 12/28/2010 09:25'!
tropoMethod
	^'on'! !

TPJsonObject subclass: #TPRecord
	instanceVariableNames: 'attempts bargein beep choices format maxSilence maxTime method minConfidence name required say transcription url password username timeout voice'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Tropo-Core'!

!TPRecord commentStamp: '<historical>' prior: 0!
https://www.tropo.com/docs/webapi/record.htm

TPRecord has not been documented yet. The class comment should describe the purpose of the class, its collaborations and its variables.

Instance Variables:
	attempts	<ProtoObject | PseudoContext>
	bargein	<ProtoObject | PseudoContext>
	beep	<ProtoObject | PseudoContext>
	choices	<ProtoObject | PseudoContext>
	format	<ProtoObject | PseudoContext>
	maxSilence	<ProtoObject | PseudoContext>
	maxTime	<ProtoObject | PseudoContext>
	method	<ProtoObject | PseudoContext>
	minConfidence	<ProtoObject | PseudoContext>
	name	<ProtoObject | PseudoContext>
	required	<ProtoObject | PseudoContext>
	say	<ProtoObject | PseudoContext>
	transcription	<ProtoObject | PseudoContext>
	url	<ProtoObject | PseudoContext>
	password	<ProtoObject | PseudoContext>
	username	<ProtoObject | PseudoContext>
	timeout	<ProtoObject | PseudoContext>
	voice	<ProtoObject | PseudoContext>!

!TPRecord methodsFor: 'accessing' stamp: 'PaulDeBruicker 12/28/2010 09:18'!
attempts
	^ attempts! !

!TPRecord methodsFor: 'accessing' stamp: 'PaulDeBruicker 12/28/2010 09:18'!
attempts: anObject
	attempts := anObject! !

!TPRecord methodsFor: 'accessing' stamp: 'PaulDeBruicker 12/28/2010 09:18'!
bargein
	^ bargein! !

!TPRecord methodsFor: 'accessing' stamp: 'PaulDeBruicker 12/28/2010 09:18'!
bargein: anObject
	bargein := anObject! !

!TPRecord methodsFor: 'accessing' stamp: 'PaulDeBruicker 12/28/2010 09:18'!
beep
	^ beep! !

!TPRecord methodsFor: 'accessing' stamp: 'PaulDeBruicker 12/28/2010 09:18'!
beep: anObject
	beep := anObject! !

!TPRecord methodsFor: 'accessing' stamp: 'PaulDeBruicker 12/28/2010 09:18'!
choices
	^ choices! !

!TPRecord methodsFor: 'accessing' stamp: 'PaulDeBruicker 12/28/2010 09:18'!
choices: anObject
	choices := anObject! !

!TPRecord methodsFor: 'accessing' stamp: 'PaulDeBruicker 12/28/2010 09:18'!
format
	^ format! !

!TPRecord methodsFor: 'accessing' stamp: 'PaulDeBruicker 12/28/2010 09:18'!
format: anObject
	format := anObject! !

!TPRecord methodsFor: 'accessing' stamp: 'PaulDeBruicker 12/28/2010 09:18'!
maxSilence
	^ maxSilence! !

!TPRecord methodsFor: 'accessing' stamp: 'PaulDeBruicker 12/28/2010 09:18'!
maxSilence: anObject
	maxSilence := anObject! !

!TPRecord methodsFor: 'accessing' stamp: 'PaulDeBruicker 12/28/2010 09:18'!
maxTime
	^ maxTime! !

!TPRecord methodsFor: 'accessing' stamp: 'PaulDeBruicker 12/28/2010 09:18'!
maxTime: anObject
	maxTime := anObject! !

!TPRecord methodsFor: 'accessing' stamp: 'PaulDeBruicker 12/28/2010 09:24'!
method
	^ method! !

!TPRecord methodsFor: 'accessing' stamp: 'PaulDeBruicker 12/28/2010 09:24'!
method: anObject
	method := anObject! !

!TPRecord methodsFor: 'accessing' stamp: 'PaulDeBruicker 12/28/2010 09:18'!
minConfidence
	^ minConfidence! !

!TPRecord methodsFor: 'accessing' stamp: 'PaulDeBruicker 12/28/2010 09:18'!
minConfidence: anObject
	minConfidence := anObject! !

!TPRecord methodsFor: 'accessing' stamp: 'PaulDeBruicker 12/28/2010 09:24'!
name
	^ name! !

!TPRecord methodsFor: 'accessing' stamp: 'PaulDeBruicker 12/28/2010 09:18'!
name: anObject
	name := anObject! !

!TPRecord methodsFor: 'accessing' stamp: 'PaulDeBruicker 12/28/2010 09:18'!
password
	^ password! !

!TPRecord methodsFor: 'accessing' stamp: 'PaulDeBruicker 12/28/2010 09:18'!
password: anObject
	password := anObject! !

!TPRecord methodsFor: 'accessing' stamp: 'PaulDeBruicker 12/28/2010 09:18'!
required
	^ required! !

!TPRecord methodsFor: 'accessing' stamp: 'PaulDeBruicker 12/28/2010 09:18'!
required: anObject
	required := anObject! !

!TPRecord methodsFor: 'accessing' stamp: 'PaulDeBruicker 12/28/2010 09:18'!
say
	^ say! !

!TPRecord methodsFor: 'accessing' stamp: 'PaulDeBruicker 12/28/2010 09:18'!
say: anObject
	say := anObject! !

!TPRecord methodsFor: 'accessing' stamp: 'PaulDeBruicker 12/28/2010 09:18'!
timeout
	^ timeout! !

!TPRecord methodsFor: 'accessing' stamp: 'PaulDeBruicker 12/28/2010 09:18'!
timeout: anObject
	timeout := anObject! !

!TPRecord methodsFor: 'accessing' stamp: 'PaulDeBruicker 12/28/2010 09:18'!
transcription
	^ transcription! !

!TPRecord methodsFor: 'accessing' stamp: 'PaulDeBruicker 12/28/2010 09:18'!
transcription: anObject
	transcription := anObject! !

!TPRecord methodsFor: 'as yet unclassified' stamp: 'PaulDeBruicker 12/28/2010 09:24'!
tropoMethod
	^'record'! !

!TPRecord methodsFor: 'accessing' stamp: 'PaulDeBruicker 12/28/2010 09:18'!
url
	^ url! !

!TPRecord methodsFor: 'accessing' stamp: 'PaulDeBruicker 12/28/2010 09:18'!
url: anObject
	url := anObject! !

!TPRecord methodsFor: 'accessing' stamp: 'PaulDeBruicker 12/28/2010 09:18'!
username
	^ username! !

!TPRecord methodsFor: 'accessing' stamp: 'PaulDeBruicker 12/28/2010 09:18'!
username: anObject
	username := anObject! !

!TPRecord methodsFor: 'accessing' stamp: 'PaulDeBruicker 12/28/2010 09:18'!
voice
	^ voice! !

!TPRecord methodsFor: 'accessing' stamp: 'PaulDeBruicker 12/28/2010 09:18'!
voice: anObject
	voice := anObject! !

TPJsonObject subclass: #TPRedirect
	instanceVariableNames: 'to name required'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Tropo-Core'!

!TPRedirect commentStamp: '<historical>' prior: 0!
https://www.tropo.com/docs/webapi/redirect.htm

TPRedirect has not been documented yet. The class comment should describe the purpose of the class, its collaborations and its variables.

Instance Variables:
	to	<ProtoObject | PseudoContext>
	name	<ProtoObject | PseudoContext>
	required	<ProtoObject | PseudoContext>!

!TPRedirect methodsFor: 'accessing' stamp: 'PaulDeBruicker 12/28/2010 09:18'!
name
	^ name! !

!TPRedirect methodsFor: 'accessing' stamp: 'PaulDeBruicker 12/28/2010 09:18'!
name: anObject
	name := anObject! !

!TPRedirect methodsFor: 'accessing' stamp: 'PaulDeBruicker 12/28/2010 09:18'!
required
	^ required! !

!TPRedirect methodsFor: 'accessing' stamp: 'PaulDeBruicker 12/28/2010 09:18'!
required: anObject
	required := anObject! !

!TPRedirect methodsFor: 'accessing' stamp: 'PaulDeBruicker 12/28/2010 09:18'!
to
	^ to! !

!TPRedirect methodsFor: 'accessing' stamp: 'PaulDeBruicker 12/28/2010 09:18'!
to: anObject
	to := anObject! !

!TPRedirect methodsFor: 'as yet unclassified' stamp: 'PaulDeBruicker 12/28/2010 09:24'!
tropoMethod
	^'redirect'! !

TPJsonObject subclass: #TPReject
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Tropo-Core'!

!TPReject commentStamp: '<historical>' prior: 0!
https://www.tropo.com/docs/webapi/reject.htm

TPReject has not been documented yet. The class comment should describe the purpose of the class, its collaborations and its variables.!

!TPReject methodsFor: 'as yet unclassified' stamp: 'PaulDeBruicker 12/28/2010 09:24'!
tropoMethod
	^'reject'! !

TPJsonObject subclass: #TPResult
	instanceVariableNames: 'actions complete error sequence sessionDuration sessionId state'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Tropo-Core'!

!TPResult commentStamp: '<historical>' prior: 0!
https://www.tropo.com/docs/webapi/result.htm

TPResult has not been documented yet. The class comment should describe the purpose of the class, its collaborations and its variables.

Instance Variables:
	actions	<ProtoObject | PseudoContext>
	complete	<ProtoObject | PseudoContext>
	error	<ProtoObject | PseudoContext>
	sequence	<ProtoObject | PseudoContext>
	sessionDuration	<ProtoObject | PseudoContext>
	sessionId	<ProtoObject | PseudoContext>
	state	<ProtoObject | PseudoContext>!

!TPResult methodsFor: 'accessing' stamp: 'PaulDeBruicker 12/28/2010 09:20'!
actions
	^ actions! !

!TPResult methodsFor: 'accessing' stamp: 'PaulDeBruicker 12/28/2010 09:20'!
actions: anObject
	actions := anObject! !

!TPResult methodsFor: 'accessing' stamp: 'PaulDeBruicker 12/28/2010 09:20'!
complete
	^ complete! !

!TPResult methodsFor: 'accessing' stamp: 'PaulDeBruicker 12/28/2010 09:20'!
complete: anObject
	complete := anObject! !

!TPResult methodsFor: 'accessing' stamp: 'PaulDeBruicker 12/28/2010 09:21'!
error
^error! !

!TPResult methodsFor: 'accessing' stamp: 'PaulDeBruicker 12/28/2010 09:21'!
error: anErrorString
error:=anErrorString ! !

!TPResult methodsFor: 'accessing' stamp: 'PaulDeBruicker 12/28/2010 09:20'!
sequence
	^ sequence! !

!TPResult methodsFor: 'accessing' stamp: 'PaulDeBruicker 12/28/2010 09:20'!
sequence: anObject
	sequence := anObject! !

!TPResult methodsFor: 'accessing' stamp: 'PaulDeBruicker 12/28/2010 09:20'!
sessionDuration
	^ sessionDuration! !

!TPResult methodsFor: 'accessing' stamp: 'PaulDeBruicker 12/28/2010 09:20'!
sessionDuration: anObject
	sessionDuration := anObject! !

!TPResult methodsFor: 'accessing' stamp: 'PaulDeBruicker 12/28/2010 09:20'!
sessionId
	^ sessionId! !

!TPResult methodsFor: 'accessing' stamp: 'PaulDeBruicker 12/28/2010 09:20'!
sessionId: anObject
	sessionId := anObject! !

!TPResult methodsFor: 'accessing' stamp: 'PaulDeBruicker 12/28/2010 09:20'!
state
	^ state! !

!TPResult methodsFor: 'accessing' stamp: 'PaulDeBruicker 12/28/2010 09:20'!
state: anObject
	state := anObject! !

!TPResult methodsFor: 'as yet unclassified' stamp: 'PaulDeBruicker 12/28/2010 09:23'!
tropoMethod
	^'result'! !

TPJsonObject subclass: #TPSay
	instanceVariableNames: 'value as name voice required'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Tropo-Core'!

!TPSay commentStamp: '<historical>' prior: 0!
https://www.tropo.com/docs/webapi/say.htm

TPSay has not been documented yet. The class comment should describe the purpose of the class, its collaborations and its variables.

Instance Variables:
	value	<ProtoObject | PseudoContext>
	as	<ProtoObject | PseudoContext>
	name	<ProtoObject | PseudoContext>
	voice	<ProtoObject | PseudoContext>
	required	<ProtoObject | PseudoContext>!

!TPSay methodsFor: 'accessing' stamp: 'PaulDeBruicker 12/28/2010 09:20'!
as
	^ as! !

!TPSay methodsFor: 'accessing' stamp: 'PaulDeBruicker 12/28/2010 09:23'!
as: anObject
	as := anObject! !

!TPSay methodsFor: 'accessing' stamp: 'PaulDeBruicker 12/28/2010 09:20'!
name
	^ name! !

!TPSay methodsFor: 'accessing' stamp: 'PaulDeBruicker 12/28/2010 09:20'!
name: anObject
	name := anObject! !

!TPSay methodsFor: 'accessing' stamp: 'PaulDeBruicker 12/28/2010 09:20'!
required
	^ required! !

!TPSay methodsFor: 'accessing' stamp: 'PaulDeBruicker 12/28/2010 09:20'!
required: anObject
	required := anObject! !

!TPSay methodsFor: 'as yet unclassified' stamp: 'PaulDeBruicker 12/28/2010 09:23'!
tropoMethod
	^'say'! !

!TPSay methodsFor: 'accessing' stamp: 'PaulDeBruicker 12/28/2010 09:20'!
value
	^ value! !

!TPSay methodsFor: 'accessing' stamp: 'PaulDeBruicker 12/28/2010 09:20'!
value: anObject
	value := anObject! !

!TPSay methodsFor: 'accessing' stamp: 'PaulDeBruicker 12/28/2010 09:20'!
voice
	^ voice! !

!TPSay methodsFor: 'accessing' stamp: 'PaulDeBruicker 12/28/2010 09:20'!
voice: anObject
	voice := anObject! !

TPJsonObject subclass: #TPSession
	instanceVariableNames: 'accountId callId form headers id initialText parameters timestamp to userType token'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Tropo-Core'!

!TPSession commentStamp: '<historical>' prior: 0!
https://www.tropo.com/docs/webapi/session.htm

TPSession has not been documented yet. The class comment should describe the purpose of the class, its collaborations and its variables.

Instance Variables:
	accountId	<ProtoObject | PseudoContext>
	callId	<ProtoObject | PseudoContext>
	form	<ProtoObject | PseudoContext>
	headers	<ProtoObject | PseudoContext>
	id	<ProtoObject | PseudoContext>
	initialText	<ProtoObject | PseudoContext>
	parameters	<ProtoObject | PseudoContext>
	timestamp	<ProtoObject | PseudoContext>
	to	<ProtoObject | PseudoContext>
	userType	<ProtoObject | PseudoContext>!

!TPSession methodsFor: 'accessing' stamp: 'PaulDeBruicker 12/28/2010 09:21'!
accountId
	^ accountId! !

!TPSession methodsFor: 'accessing' stamp: 'PaulDeBruicker 12/28/2010 09:21'!
accountId: anObject
	accountId := anObject! !

!TPSession methodsFor: 'accessing' stamp: 'PaulDeBruicker 12/28/2010 09:21'!
callId
	^ callId! !

!TPSession methodsFor: 'accessing' stamp: 'PaulDeBruicker 12/28/2010 09:21'!
callId: anObject
	callId := anObject! !

!TPSession methodsFor: 'accessing' stamp: 'PaulDeBruicker 12/28/2010 09:21'!
form
	^ form! !

!TPSession methodsFor: 'accessing' stamp: 'PaulDeBruicker 12/28/2010 09:21'!
form: anObject
	form := anObject! !

!TPSession methodsFor: 'accessing' stamp: 'PaulDeBruicker 12/28/2010 09:21'!
headers
	^ headers! !

!TPSession methodsFor: 'accessing' stamp: 'PaulDeBruicker 12/28/2010 09:21'!
headers: anObject
	headers := anObject! !

!TPSession methodsFor: 'accessing' stamp: 'PaulDeBruicker 12/28/2010 09:21'!
id
	^ id! !

!TPSession methodsFor: 'accessing' stamp: 'PaulDeBruicker 12/28/2010 09:21'!
id: anObject
	id := anObject! !

!TPSession methodsFor: 'accessing' stamp: 'PaulDeBruicker 12/28/2010 09:21'!
initialText
	^ initialText! !

!TPSession methodsFor: 'accessing' stamp: 'PaulDeBruicker 12/28/2010 09:21'!
initialText: anObject
	initialText := anObject! !

!TPSession methodsFor: 'accessing' stamp: 'PaulDeBruicker 12/28/2010 09:21'!
parameters
	^ parameters! !

!TPSession methodsFor: 'accessing' stamp: 'PaulDeBruicker 12/28/2010 09:21'!
parameters: anObject
	parameters := anObject! !

!TPSession methodsFor: 'accessing' stamp: 'PaulDeBruicker 12/28/2010 09:21'!
timestamp
	^ timestamp! !

!TPSession methodsFor: 'accessing' stamp: 'PaulDeBruicker 12/28/2010 09:21'!
timestamp: anObject
	timestamp := anObject! !

!TPSession methodsFor: 'accessing' stamp: 'PaulDeBruicker 12/28/2010 09:21'!
to
	^ to! !

!TPSession methodsFor: 'accessing' stamp: 'PaulDeBruicker 12/28/2010 09:21'!
to: anObject
	to := anObject! !

!TPSession methodsFor: 'accessing' stamp: 'PaulDeBruicker 12/28/2010 17:59'!
token
	^ token! !

!TPSession methodsFor: 'accessing' stamp: 'PaulDeBruicker 12/28/2010 17:59'!
token: anObject
	token := anObject! !

!TPSession methodsFor: 'as yet unclassified' stamp: 'PaulDeBruicker 12/28/2010 09:23'!
tropoMethod
	^'session'! !

!TPSession methodsFor: 'accessing' stamp: 'PaulDeBruicker 12/28/2010 09:21'!
userType
	^ userType! !

!TPSession methodsFor: 'accessing' stamp: 'PaulDeBruicker 12/28/2010 09:21'!
userType: anObject
	userType := anObject! !

TPJsonObject subclass: #TPStartRecording
	instanceVariableNames: 'format method url username password'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Tropo-Core'!

!TPStartRecording commentStamp: '<historical>' prior: 0!
https://www.tropo.com/docs/webapi/startrecording.htm

TPStartRecording has not been documented yet. The class comment should describe the purpose of the class, its collaborations and its variables.

Instance Variables:
	format	<ProtoObject | PseudoContext>
	method	<ProtoObject | PseudoContext>
	url	<ProtoObject | PseudoContext>
	username	<ProtoObject | PseudoContext>
	password	<ProtoObject | PseudoContext>!

!TPStartRecording methodsFor: 'accessing' stamp: 'PaulDeBruicker 12/28/2010 09:22'!
format
	^ format! !

!TPStartRecording methodsFor: 'accessing' stamp: 'PaulDeBruicker 12/28/2010 09:22'!
format: anObject
	format := anObject! !

!TPStartRecording methodsFor: 'as yet unclassified' stamp: 'PaulDeBruicker 12/28/2010 09:22'!
method
	^method! !

!TPStartRecording methodsFor: 'accessing' stamp: 'PaulDeBruicker 12/28/2010 09:22'!
method: anObject
	method := anObject! !

!TPStartRecording methodsFor: 'accessing' stamp: 'PaulDeBruicker 12/28/2010 09:22'!
password
	^ password! !

!TPStartRecording methodsFor: 'accessing' stamp: 'PaulDeBruicker 12/28/2010 09:22'!
password: anObject
	password := anObject! !

!TPStartRecording methodsFor: 'as yet unclassified' stamp: 'PaulDeBruicker 12/28/2010 09:22'!
tropoMethod
	^'startRecording'! !

!TPStartRecording methodsFor: 'accessing' stamp: 'PaulDeBruicker 12/28/2010 09:22'!
url
	^ url! !

!TPStartRecording methodsFor: 'accessing' stamp: 'PaulDeBruicker 12/28/2010 09:22'!
url: anObject
	url := anObject! !

!TPStartRecording methodsFor: 'accessing' stamp: 'PaulDeBruicker 12/28/2010 09:22'!
username
	^ username! !

!TPStartRecording methodsFor: 'accessing' stamp: 'PaulDeBruicker 12/28/2010 09:22'!
username: anObject
	username := anObject! !

TPJsonObject subclass: #TPStopRecording
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Tropo-Core'!

!TPStopRecording commentStamp: '<historical>' prior: 0!
https://www.tropo.com/docs/webapi/stoprecording.htm
TPStopRecording has not been documented yet. The class comment should describe the purpose of the class, its collaborations and its variables.!

!TPStopRecording methodsFor: 'as yet unclassified' stamp: 'PaulDeBruicker 12/28/2010 09:23'!
tropoMethod
	^'stopRecording'! !

TPJsonObject subclass: #TPTransfer
	instanceVariableNames: 'to answerOnMedia choices from headers name on required ringRepeat terminator timeout'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Tropo-Core'!

!TPTransfer commentStamp: '<historical>' prior: 0!
https://www.tropo.com/docs/webapi/transfer.htm

TPTransfer has not been documented yet. The class comment should describe the purpose of the class, its collaborations and its variables.

Instance Variables:
	to	<ProtoObject | PseudoContext>
	answerOnMedia	<ProtoObject | PseudoContext>
	choices	<ProtoObject | PseudoContext>
	from	<ProtoObject | PseudoContext>
	headers	<ProtoObject | PseudoContext>
	name	<ProtoObject | PseudoContext>
	on	<ProtoObject | PseudoContext>
	required	<ProtoObject | PseudoContext>
	ringRepeat	<ProtoObject | PseudoContext>
	terminator	<ProtoObject | PseudoContext>
	timeout	<ProtoObject | PseudoContext>!

!TPTransfer methodsFor: 'accessing' stamp: 'PaulDeBruicker 12/28/2010 09:22'!
answerOnMedia
	^ answerOnMedia! !

!TPTransfer methodsFor: 'accessing' stamp: 'PaulDeBruicker 12/28/2010 09:22'!
answerOnMedia: anObject
	answerOnMedia := anObject! !

!TPTransfer methodsFor: 'accessing' stamp: 'PaulDeBruicker 12/28/2010 09:22'!
choices
	^ choices! !

!TPTransfer methodsFor: 'accessing' stamp: 'PaulDeBruicker 12/28/2010 09:22'!
choices: anObject
	choices := anObject! !

!TPTransfer methodsFor: 'accessing' stamp: 'PaulDeBruicker 12/28/2010 09:22'!
from
	^ from! !

!TPTransfer methodsFor: 'accessing' stamp: 'PaulDeBruicker 12/28/2010 09:22'!
from: anObject
	from := anObject! !

!TPTransfer methodsFor: 'accessing' stamp: 'PaulDeBruicker 12/28/2010 09:22'!
headers
	^ headers! !

!TPTransfer methodsFor: 'accessing' stamp: 'PaulDeBruicker 12/28/2010 09:22'!
headers: anObject
	headers := anObject! !

!TPTransfer methodsFor: 'accessing' stamp: 'PaulDeBruicker 12/28/2010 09:22'!
name
	^ name! !

!TPTransfer methodsFor: 'accessing' stamp: 'PaulDeBruicker 12/28/2010 09:22'!
name: anObject
	name := anObject! !

!TPTransfer methodsFor: 'accessing' stamp: 'PaulDeBruicker 12/28/2010 09:22'!
on
	^ on! !

!TPTransfer methodsFor: 'accessing' stamp: 'PaulDeBruicker 12/28/2010 09:22'!
on: anObject
	on := anObject! !

!TPTransfer methodsFor: 'accessing' stamp: 'PaulDeBruicker 12/28/2010 09:22'!
required
	^ required! !

!TPTransfer methodsFor: 'accessing' stamp: 'PaulDeBruicker 12/28/2010 09:22'!
required: anObject
	required := anObject! !

!TPTransfer methodsFor: 'accessing' stamp: 'PaulDeBruicker 12/28/2010 09:22'!
ringRepeat
	^ ringRepeat! !

!TPTransfer methodsFor: 'accessing' stamp: 'PaulDeBruicker 12/28/2010 09:22'!
ringRepeat: anObject
	ringRepeat := anObject! !

!TPTransfer methodsFor: 'accessing' stamp: 'PaulDeBruicker 12/28/2010 09:22'!
terminator
	^ terminator! !

!TPTransfer methodsFor: 'accessing' stamp: 'PaulDeBruicker 12/28/2010 09:22'!
terminator: anObject
	terminator := anObject! !

!TPTransfer methodsFor: 'accessing' stamp: 'PaulDeBruicker 12/28/2010 09:22'!
timeout
	^ timeout! !

!TPTransfer methodsFor: 'accessing' stamp: 'PaulDeBruicker 12/28/2010 09:22'!
timeout: anObject
	timeout := anObject! !

!TPTransfer methodsFor: 'accessing' stamp: 'PaulDeBruicker 12/28/2010 09:22'!
to
	^ to! !

!TPTransfer methodsFor: 'accessing' stamp: 'PaulDeBruicker 12/28/2010 09:22'!
to: anObject
	to := anObject! !

!TPTransfer methodsFor: 'as yet unclassified' stamp: 'PaulDeBruicker 12/28/2010 09:23'!
tropoMethod
	^'transfer'! !

Object subclass: #TPService
	instanceVariableNames: 'root'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Tropo-Core'!

!TPService class methodsFor: 'as yet unclassified' stamp: 'PaulDeBruicker 12/28/2010 14:54'!
apiVersion
	^'1.0'! !

!TPService class methodsFor: 'as yet unclassified' stamp: 'PaulDeBruicker 12/28/2010 14:54'!
instancesOf: aClass
	^ self default instancesOf: aClass! !

!TPService class methodsFor: 'as yet unclassified' stamp: 'PaulDeBruicker 4/11/2011 10:29'!
tropoRestUrl 

		^'http://api.tropo.com/1.0/sessions'! !

!TPService class methodsFor: 'as yet unclassified' stamp: 'PaulDeBruicker 12/28/2010 14:54'!
tropoUrl 

		^'http://api.tropo.com/', self apiVersion , '/sessions'! !

!TPService methodsFor: 'as yet unclassified' stamp: 'PaulDeBruicker 12/28/2010 14:54'!
at: aString
	^ self root at: aString ifAbsentPut: [ OrderedCollection new ]! !

!TPService methodsFor: 'as yet unclassified' stamp: 'PaulDeBruicker 12/28/2010 14:54'!
instancesOf: aClass
	^ self at: aClass name! !

!TPService methodsFor: 'as yet unclassified' stamp: 'PaulDeBruicker 12/28/2010 14:54'!
root
	^ root ifNil: [ root := IdentityDictionary new ]! !

!TPService methodsFor: 'as yet unclassified' stamp: 'PaulDeBruicker 9/6/2011 18:45'!
startNewSession
	| dict response json |
	dict := GRSmallDictionary new.
	dict at: 'token' put: self class tropoToken.
	response := ZnClient post: self class tropoRestUrl data: (ZnEntity text: dict asJson).
	json := Json readFrom: response entity string readStream.
	^ json at: 'id' ifAbsent: [ nil ]! !

TPService subclass: #TPSmsService
	instanceVariableNames: ''
	classVariableNames: 'OutgoingMessageQueue'
	poolDictionaries: ''
	category: 'Tropo-Core'!

TPSmsService class
	instanceVariableNames: 'default'!

TPSmsService class
	instanceVariableNames: 'default'!

!TPSmsService class methodsFor: 'as yet unclassified' stamp: 'PaulDeBruicker 12/29/2010 13:43'!
OutgoingMessageQueue 
	^OutgoingMessageQueue ! !

!TPSmsService class methodsFor: 'as yet unclassified' stamp: 'PaulDeBruicker 12/29/2010 13:44'!
OutgoingMessageQueue: aSharedQueue
	OutgoingMessageQueue :=aSharedQueue! !

!TPSmsService class methodsFor: 'as yet unclassified' stamp: 'PaulDeBruicker 12/28/2010 14:49'!
default
	^ default ifNil: [ default := TPSmsService new ]! !

!TPSmsService class methodsFor: 'as yet unclassified' stamp: 'PaulDeBruicker 12/29/2010 20:01'!
default: aTPSmsService
	default := aTPSmsService ! !

!TPSmsService class methodsFor: 'as yet unclassified' stamp: 'PaulDeBruicker 4/11/2011 11:06'!
emptyOutgoingMessageQueue
	OutgoingMessageQueue :=SharedQueue  new.! !

!TPSmsService class methodsFor: 'as yet unclassified' stamp: 'PaulDeBruicker 9/6/2011 18:11'!
findNextResponseFor: aConversation
	^ OutgoingMessageQueue findFirst:[:each | ((each at: 'tropo') at:'message') at: 'id' = aConversation id]
	! !

!TPSmsService class methodsFor: 'as yet unclassified' stamp: 'PaulDeBruicker 12/29/2010 13:10'!
initialize

	"
	self initialize
	"
	OutgoingMessageQueue:=SharedQueue new.! !

!TPSmsService class methodsFor: 'as yet unclassified' stamp: 'PaulDeBruicker 12/29/2010 13:42'!
oldestOutgoingMessage 
	^OutgoingMessageQueue nextOrNil.! !

!TPSmsService class methodsFor: 'accessing' stamp: 'PaulDeBruicker 9/6/2011 18:53'!
outgoingMessageForId: anId
	^OutgoingMessageQueue findFirst:[:each | each key = anId ] ! !

!TPSmsService class methodsFor: 'as yet unclassified' stamp: 'PaulDeBruicker 12/29/2010 13:13'!
queueOutgoingMessage: aJson

	OutgoingMessageQueue nextPut: aJson.! !

!TPSmsService class methodsFor: 'as yet unclassified' stamp: 'PaulDeBruicker 12/29/2010 19:06'!
tropoToken 
	"you get this afer registering at tropo.com"
	! !

!TPSmsService methodsFor: 'as yet unclassified' stamp: 'PaulDeBruicker 12/29/2010 14:16'!
sms: aMessage to: aPhoneNumber
|x y|
x:=Dictionary new.
y:=Dictionary new.
y at:'message' put:(TPMessage new network: 'SMS';
				to: aPhoneNumber;
				channel:'TEXT';
				say: (TPSay new value: aMessage )).
x at: 'tropo' put: y.
^x asJson! !

TPSmsService subclass: #TPSmsSimpleClient
	instanceVariableNames: 'message token'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Tropo-Core'!

!TPSmsSimpleClient commentStamp: '<historical>' prior: 0!
You can send sms to numbers in the USA .  

See here: http://blog.tropo.com/2010/11/19/simple-post-and-get-interface-to-tropo-sms/

After registering at tropo.com create a new Tropo Scripting application that uses the simpleMessage.php script found on their github.


Then you can use TPSendSms class>>to:withMessage: to send an SMS.  You need to set a voice/sms number on tropo and also change the token on the class side of TPSendSms. 

Uses HTTPSocket.  


If you're going to use this you can also use TPKomWaitForSms class >> handleRequestSimpleMessage:  to receive SMS messages from tropo.  The drawback vs using the TPSendJsonSms  is that you can only send and receive SMS messages, but not use any of their other features that you can add by sending tropo TropoML JSON objects.  !

!TPSmsSimpleClient class methodsFor: 'as yet unclassified' stamp: 'PaulDeBruicker 12/27/2010 20:31'!
to: aPhoneNumber withMessage: aString
	^self new sendSms: aString to: aPhoneNumber usingToken: self tropoToken ! !

!TPSmsSimpleClient class methodsFor: 'as yet unclassified' stamp: 'PaulDeBruicker 12/27/2010 20:30'!
to: aPhoneNumber withMessage: aString usingToken: aToken
	^self new sendSms: aString to: aPhoneNumber usingToken: aToken ! !

!TPSmsSimpleClient class methodsFor: 'as yet unclassified' stamp: 'PaulDeBruicker 4/11/2011 20:51'!
tropoToken 
	"you get this afer registering at tropo.com"
! !

!TPSmsSimpleClient methodsFor: 'as yet unclassified' stamp: 'PaulDeBruicker 12/14/2010 11:59'!
initialize 


super initialize .
message :=OrderedCollection new.! !

!TPSmsSimpleClient methodsFor: 'as yet unclassified' stamp: 'PaulDeBruicker 12/29/2010 16:25'!
sendSms: aString to: aPhoneNumber usingToken: aToken
	^ HTTPSocket httpGetDocument: self class tropoUrl args: (self smsArgsWith: aString to: aPhoneNumber using: aToken)! !

!TPSmsSimpleClient methodsFor: 'as yet unclassified' stamp: 'PaulDeBruicker 12/27/2010 20:31'!
smsArgsWith: a160CharacterLongString to: aPhoneNumber using: aToken

	|x|
	x:=Dictionary new.
	x at: 'action' put: 'create'.
	x at: 'token' put: aToken.
	x at: 'to' put: aPhoneNumber.
	x at: 'msg' put: a160CharacterLongString.
	x at: 'network' put:'SMS'.
	^x
	! !

TPSmsService subclass: #TPZincSmsJsonClient
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Tropo-Core'!

!TPZincSmsJsonClient commentStamp: 'PaulDeBruicker 4/11/2011 11:12' prior: 0!
You can send sms messages to numbers in the USA. 


This allows you to send SMS messages without using a hosted script which allows you to develop the back end of your application in smalltalk and just send tropo TropoML JSON objects.  


It also illustrates how to create and send TropoML JSON objects.  

How to set it up:


- Make an account on Tropo.  Add an application, set the URL to point to your server.  

-  Choose a port to listen on and either proxy the URL to that port, or just run it on port 80

- In TPSmsService enter your Sms service token from tropo in the tropoToken method.

-  In a workspace run TPZincWaitForSms startOn: yourChosenPortNumber
	That starts an instance of ZnServer defaultServerClass listening on the port you choose and running TPZincWaitForSms class>>handleRequest: 
	when a request comes in.  


-  In a workspace do
		TPZincSendSmsJson  to: yourPhoneNumber withMessage: 'I sent a SMS message from smalltalk.'
		
		yourPhoneNumber must be in the usa, have the area code, and start with +1
		tropo will split the message into 160 character chunks at the nearest workd break if you're sending a long message.!

!TPZincSmsJsonClient class methodsFor: 'as yet unclassified' stamp: 'PaulDeBruicker 9/6/2011 17:30'!
to: aPhoneNumber withMessage: aString
	^self new sendSms: aString to: aPhoneNumber ! !

!TPZincSmsJsonClient methodsFor: 'as yet unclassified' stamp: 'PaulDeBruicker 9/6/2011 18:57'!
sendSms: aString to: aPhoneNumber
	| x y json id |
id:=self startNewSession.
	id notNil
		ifTrue: [ 
			x := Dictionary new.
			y := Dictionary new.
			y
				at: 'message'
				put:
					((TPMessage new)
						network: 'SMS';
						to: aPhoneNumber;
						channel: 'TEXT';
						say: (TPSay new value: aString)).
			x at: 'tropo' put: y.
			json := x asJsonString.
		
			 TPSmsService queueOutgoingMessage: id withBlanksTrimmed -> (ZnStringEntity text: json) ]! !

TPSmsService subclass: #TPZincSmsServer
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Tropo-Core'!

TPZincSmsServer class
	instanceVariableNames: 'httpService'!

TPZincSmsServer class
	instanceVariableNames: 'httpService'!

!TPZincSmsServer class methodsFor: 'as yet unclassified' stamp: 'PaulDeBruicker 9/6/2011 19:01'!
handleRequest: aRequest
	| jsonData userType from conversation stream sessionId response |
	"should only be a POST from tropo"
	
	aRequest method == #POST
		ifTrue: [ 
			stream := aRequest entity readStream.	
			jsonData := Json readFrom: stream.
		
			(jsonData at: 'session') notNil
				ifTrue: [ 
					from := (jsonData at: 'session') at: 'from'.
					sessionId := (jsonData at: 'session') at: 'id'.
					userType := (jsonData at: 'session') at: 'userType' ]
				ifFalse: [ sessionId := (jsonData at: 'result') at: 'sessionId' ].
			
			conversation := from isNil
				ifTrue: [ TPSmsConversation findById: sessionId ]
				ifFalse: [ (TPSmsConversation findByFrom: from) id: sessionId ].
			conversation requests add: jsonData.
		
			response := userType = 'NONE'
				ifTrue: [ TPSmsService outgoingMessageForId: conversation id ]
				ifFalse: [ TPSmsService findNextResponseFor: conversation. ].
				response ifNotNil:[response:=response value].
			conversation responses add: response.

			conversation from isNil
				ifFalse: [conversation printLastMessageToTranscipt].
			conversation inspect ].
	
	^ ZnResponse ok: response! !

!TPZincSmsServer class methodsFor: 'as yet unclassified' stamp: 'PaulDeBruicker 4/11/2011 20:51'!
handleRequestJson: aRequest
	| jsonData userType from conversation stream sessionId response |
	"should only be a POST from tropo"
	
	aRequest method == #POST
		ifTrue: [ 
			stream := aRequest entity readStream.	"self halt."
			jsonData := Json readFrom: stream.
		"	self halt."
			(jsonData at: 'session') notNil
				ifTrue: [ 
					from := (jsonData at: 'session') at: 'from'.
					sessionId := (jsonData at: 'session') at: 'id'.
					userType := (jsonData at: 'session') at: 'userType' ]
				ifFalse: [ sessionId := (jsonData at: 'result') at: 'sessionId' ].
			"	self halt."
			conversation := from isNil
				ifTrue: [ TPSmsConversation findById: sessionId ]
				ifFalse: [ (TPSmsConversation findByFrom: from) id: sessionId ].
			conversation requests add: jsonData.
			response := userType = 'NONE'
				ifTrue: [ TPSmsService oldestOutgoingMessage ]
				ifFalse: [ TPSmsService findNextResponseFor: conversation. ].
			conversation responses add: response.
		"	self halt."
			conversation from isNil
				ifFalse: [conversation printLastMessageToTranscipt].
			conversation inspect ].
	"	self halt."
	^ ZnResponse ok: response! !

!TPZincSmsServer class methodsFor: 'as yet unclassified' stamp: 'PaulDeBruicker 4/11/2011 20:51'!
handleRequestSimpleMessage: aRequest
	| to from msg fields conversation stream |
	"should only be a POST from tropo"


	aRequest method ==#POST
		ifTrue: [ 
			fields:=aRequest fields.
		msg:=TPMessage new.
		msg from: (fields at: 'from');
			to: (fields at: 'to');
			say: (fields at: 'msg').
		"	self halt."
			conversation := TPSmsConversation findByFrom: msg from.
			conversation messages add: msg.	
		"	self halt."
			conversation printLastMessageToTranscipt.
			conversation inspect.].
 ^ZnResponse ok: (ZnStringEntity text: '') ! !

!TPZincSmsServer class methodsFor: 'as yet unclassified' stamp: 'PaulDeBruicker 4/11/2011 09:13'!
httpService 
	^httpService ! !

!TPZincSmsServer class methodsFor: 'as yet unclassified' stamp: 'PaulDeBruicker 4/11/2011 09:13'!
httpService: anHttpService
	httpService:=anHttpService ! !

!TPZincSmsServer class methodsFor: 'as yet unclassified' stamp: 'PaulDeBruicker 4/11/2011 10:48'!
startOn: aPort

self stopOn: aPort.


self httpService: (ZnServer startOn: aPort).
self httpService delegate: self.
! !

!TPZincSmsServer class methodsFor: 'as yet unclassified' stamp: 'PaulDeBruicker 4/12/2011 12:05'!
startOn: aPort log: aBoolean

self startOn: aPort.
aBoolean ifTrue:[self httpService logToTranscript.]! !

!TPZincSmsServer class methodsFor: 'as yet unclassified' stamp: 'PaulDeBruicker 4/11/2011 10:56'!
stopOn: aPortNumber
ZnServer defaultServerClass allInstances do: [:eachService | eachService port = aPortNumber ifTrue:[eachService stop]].! !

TPService subclass: #TPVoiceService
	instanceVariableNames: ''
	classVariableNames: 'OutgoingCallQueue'
	poolDictionaries: ''
	category: 'Tropo-Core'!

TPVoiceService class
	instanceVariableNames: 'default'!

TPVoiceService class
	instanceVariableNames: 'default'!

!TPVoiceService class methodsFor: 'as yet unclassified' stamp: 'PaulDeBruicker 12/29/2010 16:57'!
OutgoingCallQueue
	^OutgoingCallQueue! !

!TPVoiceService class methodsFor: 'as yet unclassified' stamp: 'PaulDeBruicker 12/29/2010 16:57'!
OutgoingCallQueue: aSharedQueue
	OutgoingCallQueue:=aSharedQueue ! !

!TPVoiceService class methodsFor: 'as yet unclassified' stamp: 'PaulDeBruicker 12/28/2010 14:54'!
default
	^ default ifNil: [ default := TPVoiceService new ]! !

!TPVoiceService class methodsFor: 'as yet unclassified' stamp: 'PaulDeBruicker 12/29/2010 20:02'!
default: aTPSmsService
	default := aTPSmsService ! !

!TPVoiceService class methodsFor: 'as yet unclassified' stamp: 'PaulDeBruicker 4/11/2011 11:06'!
emptyOutgoingCallQueue
	OutgoingCallQueue :=SharedQueue  new.! !

!TPVoiceService class methodsFor: 'as yet unclassified' stamp: 'PaulDeBruicker 12/29/2010 16:58'!
findNextResponseFor: aConversation
	^ OutgoingCallQueue findFirst:[:each | ((each at: 'tropo') at:'message') at: 'to' = aConversation from]
	! !

!TPVoiceService class methodsFor: 'as yet unclassified' stamp: 'PaulDeBruicker 12/29/2010 18:47'!
initialize 
"
self initialize
"
	OutgoingCallQueue:=SharedQueue new.! !

!TPVoiceService class methodsFor: 'as yet unclassified' stamp: 'PaulDeBruicker 12/29/2010 16:58'!
oldestOutgoingCall 
	^OutgoingCallQueue nextOrNil.! !

!TPVoiceService class methodsFor: 'as yet unclassified' stamp: 'PaulDeBruicker 12/29/2010 16:58'!
queueOutgoingCall: aJson

	OutgoingCallQueue nextPut: aJson.! !

!TPVoiceService class methodsFor: 'as yet unclassified' stamp: 'PaulDeBruicker 4/11/2011 20:49'!
tropoToken
! !

TPVoiceService subclass: #TPZincJsonVoiceClient
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Tropo-Core'!

!TPZincJsonVoiceClient commentStamp: 'PaulDeBruicker 4/11/2011 11:15' prior: 0!
You can make telephone calls to numbers in the USA. 


This allows you to make telephone calls without using a hosted script which allows you to develop the back end of your application in smalltalk and just send tropo TropoML JSON objects.  


It also illustrates how to create and send TropoML JSON objects.  

How to set it up:


- Make an account on Tropo.  Add an application, set the URL to point to your server.  

-  Choose a port to listen on and either proxy the URL to that port, or just run it on port 80

- In TPVoiceService enter your Voice service token from tropo in the tropoToken method.

-  In a workspace run TPZincWaitForCall startOn: yourChosenPortNumber
	That starts an instance of ZnServer defaultServerClass listening on the port you choose and running TPZincWaitForCall class>>handleRequest: 
	when a request comes in.  


-  In a workspace do
		TPZincMakeCallJson  to: yourPhoneNumber withMessage: 'I sent a SMS message from smalltalk.'
		
		yourPhoneNumber must be in the usa, have the area code, and start with +1
		tropo will split the message into 160 character chunks at the nearest workd break if you're sending a long message.
		
	There are many more options you can set and you can script a conversation.  The docs on Tropo.com are good and the skeletons for the JSON objects are set up in this package.!

!TPZincJsonVoiceClient class methodsFor: 'as yet unclassified' stamp: 'PaulDeBruicker 4/11/2011 11:00'!
to: aPhoneNumber withMessage: aString
	^self new say: aString to: aPhoneNumber ! !

!TPZincJsonVoiceClient methodsFor: 'as yet unclassified' stamp: 'PaulDeBruicker 4/11/2011 14:36'!
say: aString to: aPhoneNumber
	| x y json |
	self startNewSession
		ifTrue: [ 
			x := Dictionary new.
			y := Dictionary new.
			y
				at: 'message'
				put:
					((TPMessage new)
						to: aPhoneNumber;
						channel: 'VOICE';
						say: (TPSay new value: aString)).
			x at: 'tropo' put: y.
			json := x asJsonString.
			 TPVoiceService queueOutgoingCall: (ZnStringEntity text: json) ]! !

TPVoiceService subclass: #TPZincVoiceServer
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Tropo-Core'!

TPZincVoiceServer class
	instanceVariableNames: 'httpService'!

TPZincVoiceServer class
	instanceVariableNames: 'httpService'!

!TPZincVoiceServer class methodsFor: 'as yet unclassified' stamp: 'PaulDeBruicker 4/11/2011 10:50'!
handleRequest: aRequest
	| jsonData userType from conversation stream sessionId response |
	"should only be a POST from tropo"
"	self halt."
	aRequest method == #POST
		ifTrue: [ 
			stream := aRequest entity readStream.	
			jsonData := Json readFrom: stream.
	
			(jsonData at: 'session') notNil
				ifTrue: [ 
					from := (jsonData at: 'session') at: 'from'.
					sessionId := (jsonData at: 'session') at: 'id'.
					userType := (jsonData at: 'session') at: 'userType' ]
				ifFalse: [ sessionId := (jsonData at: 'result') at: 'sessionId' ].
			"	self halt."
			conversation := from isNil
				ifTrue: [ TPVoiceConversation findById: sessionId ]
				ifFalse: [ (TPVoiceConversation findByFrom: from) id: sessionId ].
			conversation requests add: jsonData.
			response := userType = 'NONE'
				ifTrue: [ TPVoiceService oldestOutgoingCall ]
				ifFalse: [ TPVoiceService findNextResponseFor: conversation. ].
			conversation responses add: response.
			"conversation printLastMessageToTranscipt."
			conversation inspect ].
		"self halt."
	^ ZnResponse ok: response! !

!TPZincVoiceServer class methodsFor: 'as yet unclassified' stamp: 'PaulDeBruicker 4/11/2011 10:47'!
httpService 
	^httpService ! !

!TPZincVoiceServer class methodsFor: 'as yet unclassified' stamp: 'PaulDeBruicker 4/11/2011 10:47'!
httpService: anHttpService
	httpService:=anHttpService ! !

!TPZincVoiceServer class methodsFor: 'as yet unclassified' stamp: 'PaulDeBruicker 4/11/2011 10:48'!
startOn: aPort

self stopOn: aPort.

self httpService: (ZnServer startOn: aPort).
self httpService delegate: self. 
! !

!TPZincVoiceServer class methodsFor: 'as yet unclassified' stamp: 'PaulDeBruicker 4/12/2011 12:06'!
startOn: aPort log: aBoolean

self startOn: aPort.
aBoolean ifTrue:[self httpService logToTranscript.]! !

!TPZincVoiceServer class methodsFor: 'as yet unclassified' stamp: 'PaulDeBruicker 4/11/2011 10:55'!
stopOn: aPortNumber
ZnServer defaultServerClass allInstances do: [:eachService | eachService port = aPortNumber ifTrue:[eachService stop]].! !
TPSmsService initialize!
TPVoiceService initialize!
